/*
IE6 Multiple Class Fix jQuery Plug In
Author: Ben Green (bgreen@chicowebdesign.com)
Date: 101118
License: Free
*/
jQuery(function($){


	//conditional for which browsers you want to support (ie6)
	if(false || $.browser.msie && parseInt($.browser.version)==6){

		var myCss='';
		var toChange=[];

		function countOccurrence(instr,searchFor){
			var pos=instr.indexOf(searchFor);
			var i=0;
			while(pos>-1){
				i++;
				pos=instr.indexOf(searchFor,pos+1);
			};
			return i;
		};
	
		// Returns true if the passed value is found in the
		// array. Returns false if it is not.
		function inArray(myArray,value,caseSensitive) {
			var i;
			for (i=0; i < myArray.length; i++) {
				// use === to check for Matches. ie., identical (===),
				if(caseSensitive){ //performs match even the string is case sensitive
					if (myArray[i].toLowerCase() == value.toLowerCase()) {
						return true;
					};
				}else{
					if (myArray[i] == value) {
						return true;
					};
				};
			};
			return false;
		};	

		function matchChange(instr){
			var toApply=[];
			instr=instr.split(" ");
			for(var i=0;i<toChange.length;i++){
				var hasAll=true;
				var cRule=toChange[i];
				for(var j=0;j<cRule.length;j++){
					if(cRule[j]!=""){
						cRule[j]=cRule[j].replace(/:hover/ig,'').replace(/:focus/ig,'').replace(/:active/ig,'');
						if(!inArray(instr,cRule[j],false)) hasAll=false;
					};
				};
				if(hasAll) toApply.push(i);
			};
			return toApply;
		};
	
		function readCss(conts,path){
			var buffer='';
			//get rid of comments
			conts=conts.replace(/\/\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+\//g,'');
			var rules=conts.split("}");
			
			for(var i=0;i<rules.length;i++){
				var spl=rules[i].indexOf("{");
				if(spl>-1){
					var sel=$.trim(rules[i].substr(0,spl).replace(/,/g,' , '));
					var cssText=$.trim(rules[i].substr(spl+1));
				
					//make paths relative to the stylesheet work out
					if(path){
						var urlPos=cssText.indexOf("url(");
						while(urlPos>-1){
							//don't do any working on absolute urls
							if(cssText.substr(urlPos+4,7).toLowerCase()!="http://" &&
								cssText.substr(urlPos+4,1)!="/")
							{
								cssText=cssText.substr(0,urlPos+4)+path+cssText.substr(urlPos+4);
							}
							//seek to next
							urlPos=cssText.indexOf("url(",urlPos+1);
						};
					};
					
					//make the selector not have multiple classes
					var multiSel=sel.split(",");
					for(var j=0;j<multiSel.length;j++){
						var cSel=$.trim(multiSel[j]);
						var sSpl=cSel.split(" ");
						var changed=false;
						for(var k=0;k<sSpl.length;k++){
							if(countOccurrence(sSpl[k],".")>1){
								toChange.push(sSpl[k].split(".").slice(1));
								sSpl[k]=sSpl[k].replace(/\./g,"-mc-");
								sSpl[k]=sSpl[k].substr(0,sSpl[k].indexOf("-mc-"))+"."+sSpl[k].substr(sSpl[k].indexOf("-mc-")+4);
								changed=true;
							};
						};
						if(changed){
							multiSel[j]=sSpl.join(" ");
						};
					}
					sel=multiSel.join(", ");
					
					buffer+="\n"+sel+" {"+cssText+"}\n";
				};
			};
			
			return buffer;
			
		};
		$.fn.extend({multipleClassReadStyleSheets:function(){
			//read style tags
			$("style").each(function(){
				var conts=$(this).html();
				myCss+=readCss(conts);
				$(this).html("");
			});
		
			//read linked stylesheets
			$("link[rel=stylesheet]").each(function(){
				var href=$(this).attr("href");
				//dont load any stylesheets from other domains
				if(href.substr(0,7).toLowerCase()!="http://"){
					var base="";
					
					if($("base").length){
						base=$("base").attr("href");
					
						if(base.substr(base.length-2)!="/" &&
							href.substr(0,1)!="/")
								base+="/";
					}
					
					
					var path=href.slice(0, href.lastIndexOf("/") + 1);
					$.ajax({
						async: false,
						url: $(this).attr("href"),
						success: function(conts) {
							myCss+=readCss(conts,base+path);
							}
					});
					$(this).attr("href","");
				}
			});	
			//add the modified styles to the page
			$("head").append("<style>\n"+myCss+"</style>");
			//debug: $("body").append("<pre>\n"+myCss+"</pre>");
		},
		applyMultipleClasses:function(root){
			//update class tags on the elements
			if(toChange.length){
				if(!root) root=document;
				$("*",root).each(function(){
					var cCls=$(this).attr("class");
					if(cCls){
						var addCls=matchChange(cCls);
						if(addCls.length){
							for(var i=0;i<addCls.length;i++){
								var cCls=addCls[i];
								cCls=toChange[cCls].join("-mc-");
								if(cCls.substr(0,4)=="-mc-") cCls=cCls.substr(4);
								$(this).addClass(cCls);
							};
						};
					
					};
				});
			};
		}});
		//call above function
		//commented out so i can call it when i want!
		$.fn.multipleClassReadStyleSheets();
		$.fn.applyMultipleClasses();  
		
		
	//end ie conditional
	}else{
		//provide a dummy function for all other browsers so there aren't any errors
	
		$.fn.extend({multipleClassReadStyleSheets:function(){return false;},
			applyMultipleClasses:function(root){
				return false;
			}});  
	};
});
